/*
 * State.cpp
 *
 *  Created on: 21 Nov 2019
 *      Author: webpigeon
 */

#include "state.h"

int32_t entity_type::get_property(const string& name, int32_t default_val) const {
	try {
		return properties.at(name);
	} catch (const std::out_of_range&){
		if (parent == NULL) {
			return default_val;
		} else{
			return parent->get_property(name, default_val);
		}
	}
}

int32_t entity::get_property(const string& name) const {
	return get_property(name, 0);
}

int32_t entity::get_property(const string& name, int32_t val) const {
	try {
		return properties.at(name);
	} catch (const std::out_of_range&) {

		if (type != NULL){
			return type->get_property(name, val);
		}

		return val;
	}
}

void state::add_entity(entity entity){
	entities.push_back(entity);
}

state::state() {
	this->turn = 0;
}

state::~state() {
	// TODO Auto-generated destructor stub
}

